#include <Wire.h>
#include <MIDIUSB.h>
#include "Adafruit_MPR121.h"
#ifndef _BV
#define _BV(bit) (1 << (bit)) 
#endif
#include <Bounce.h>
int octave = 48;
// Ici on défini les touch pin
int touchRead_pin_4 = 25;
int touchRead_pin_5 = 32;
int touchRead_pin_1 = 23; 
int touchRead_pin_2 = 0; 
int touchRead_pin_3 = 1;
int touchRead_pin_6 = 33;
int thresh = 1200;
int thresh1 = 2000;
int thresh2 = 800;
int thresh3 = 1460;
int play_flag_1 = 0; 
int play_flag_2 = 0;
int play_flag_3 = 0;
int play_flag_4 = 0;
int play_flag_5 = 0;
int play_flag_6 = 0;
int current_1; 
int current_2;
int current_3;
int current_4;
int current_5;
int current_6;
//delay pour les potentiomètre :
int delay_time = 3;
int delay_time1 = 100; 
// Pour les Switch :
Bounce button2 = Bounce(2, 5);
Bounce button3 = Bounce(3, 5);
Bounce button4 = Bounce(4, 5);
Bounce button5 = Bounce(5, 5);
Bounce button6 = Bounce(6, 5);
Bounce button7 = Bounce(7, 5);
Bounce button8 = Bounce(8, 5);
Bounce button9 = Bounce(9, 5);
Bounce button10 = Bounce(10, 5);
Bounce button11 = Bounce(11, 5);
Bounce button12 = Bounce(12, 5);

Bounce button24 = Bounce(24, 5);
Bounce button26 = Bounce(26, 5);
Bounce button27 = Bounce(27, 5);
Bounce button31 = Bounce(31, 5);

Adafruit_MPR121 cap = Adafruit_MPR121();
 
uint16_t lasttouched = 0;
uint16_t currtouched = 0;
 
void setup() {
 
    while (!Serial);
 
    cap.begin(0x5A);
 
    usbMIDI.begin();
    Serial.begin(115200);

    // on défini les switch input
  pinMode(2, INPUT_PULLUP);
  pinMode(3, INPUT_PULLUP);
  pinMode(4, INPUT_PULLUP);
  pinMode(5, INPUT_PULLUP);
  pinMode(6, INPUT_PULLUP);
  pinMode(7, INPUT_PULLUP);
  pinMode(8, INPUT_PULLUP);
  pinMode(9, INPUT_PULLUP);
  pinMode(10, INPUT_PULLUP);
  pinMode(11, INPUT_PULLUP);
  pinMode(12, INPUT_PULLUP);
  
  pinMode(24, INPUT_PULLUP);
  pinMode(26, INPUT_PULLUP);
  pinMode(27, INPUT_PULLUP);
  pinMode(31, INPUT_PULLUP);
 
}
// on défini les analog input
int previousA0 = -1;
int previousA1 = -1;
int previousA2 = -1;
int previousA3 = -1;
int previousA6 = -1;
int previousA7 = -1;
int previousA8 = -1;
int previousA10 = -1;
int previousA11 = -1;
int previousA12 = -1;
int previousA13 = -1;
int previousA14 = -1;
int previousA17 = -1;
int previousA18 = -1;
int previousA19 = -1;
elapsedMillis msec = 0;

void loop() {
// current_4,5,6 c'est les 3 touch Plates
 current_4 = touchRead(touchRead_pin_4); 

  if(current_4 > thresh2 && play_flag_4 == 0) {
    play_flag_4 = 1;
    usbMIDI.sendControlChange(2, 127, 1); 
    delay(delay_time);  
  }
  if(current_4 < thresh && play_flag_4 == 1) {
    play_flag_4 = 0;
    usbMIDI.sendControlChange(2, 0, 1);
    delay(delay_time); 
  }

  current_5 = touchRead(touchRead_pin_5); 

  if(current_5 > thresh && play_flag_5 == 0) {
    play_flag_5 = 1;
    usbMIDI.sendControlChange(3, 127, 1); 
    delay(delay_time);  
  }
  if(current_5 < thresh && play_flag_5 == 1) {
    play_flag_5 = 0;
    usbMIDI.sendControlChange(3, 0, 1);
    delay(delay_time); 
  }

  current_6 = touchRead(touchRead_pin_6); 

  if(current_6 > thresh && play_flag_6 == 0) {
    play_flag_6 = 1;
    usbMIDI.sendControlChange(4, 127, 1); 
    delay(delay_time);  
  }
  if(current_6 < thresh && play_flag_6 == 1) {
    play_flag_6 = 0;
    usbMIDI.sendControlChange(4, 0, 1);
    delay(delay_time); 
  }
  //On update les switchs :
  button2.update();
  button3.update();
  button4.update();
  button5.update();
  button6.update();
  button7.update();
  button8.update();
  button9.update();
  button10.update();
  button11.update();
  button12.update();
  
  button24.update();
  button26.update();
  button27.update();
  button31.update();

//current_1 c'est la dernière touche DO
current_1 = touchRead(touchRead_pin_1); 
  
  if(current_1 > thresh1 && play_flag_1 == 0) {
    play_flag_1 = 1;
    usbMIDI.sendNoteOn(12+octave, 127, 1); 
    delay(delay_time); 
  }

  if(current_1 < thresh1 && play_flag_1 == 1) {
    play_flag_1 = 0;
    usbMIDI.sendNoteOff(12+octave, 0, 1); 
    delay(delay_time); 
  }
//current_2 c'est l'octave -12
current_2 = touchRead(touchRead_pin_2); 

  if(current_2 > thresh && play_flag_2 == 0) {
    play_flag_2 = 1; 
    delay(delay_time1); 
  }
  if(current_2 < thresh && play_flag_2 == 1) {
    play_flag_2 = 0;
    octave = octave - 12; 
    delay(delay_time1); 
  }
  //current_3 c'est l'octave +12
current_3 = touchRead(touchRead_pin_3); 

  if(current_3 > thresh && play_flag_3 == 0) {
    play_flag_3 = 1;
    delay(delay_time1);  
  }
  if(current_3 < thresh && play_flag_3 == 1) {
    play_flag_3 = 0;
    octave = octave + 12; 
    delay(delay_time1); 
  }
// ici c'est les potentiomètres :

if (msec >= 20) {
    msec = 0;
    int n0 = analogRead(A0) / 8;
    int n1 = analogRead(A1) / 8;
    int n2 = analogRead(A2) / 8;
    int n3 = analogRead(A3) / 8;
    int n6 = analogRead(A6) / 8;
    int n7 = analogRead(A7) / 8;
    int n8 = analogRead(A8) / 8;
    int n10 = analogRead(A10) / 8;
    int n11 = analogRead(A11) / 8;
    int n12 = analogRead(A12) / 8;
    int n13 = analogRead(A13) / 8;
    int n14 = analogRead(A14) / 8;
    int n17 = analogRead(A17) / 8;
    int n18 = analogRead(A18) / 8;
    int n19 = analogRead(A19) / 8;
    if (n0 != previousA0) {
      usbMIDI.sendControlChange(5, analogRead(0)>>3, 1);
      previousA0 = n0;
      delay(10); 
    }
    if (n1 != previousA1) {
      usbMIDI.sendControlChange(6, analogRead(1)>>3, 1);
      previousA1 = n1;
      delay(10);
    }
    if (n2 != previousA2) {
      usbMIDI.sendControlChange(7, analogRead(2)>>3, 1);
      previousA2 = n2;
      delay(10);
    }
    if (n3 != previousA3) {
      usbMIDI.sendControlChange(8, analogRead(3)>>3, 1);
      previousA3 = n3;
      delay(10);
    }
    if (n6 != previousA6) {
      usbMIDI.sendControlChange(9, analogRead(6)>>3, 1);
      previousA6 = n6;
      delay(10);
    }
    if (n7 != previousA7) {
      usbMIDI.sendControlChange(26, analogRead(7)>>3, 1);
      previousA7 = n7;
      delay(10);
    }
    if (n8 != previousA8) {
      usbMIDI.sendControlChange(27, analogRead(8)>>3, 1);
      previousA8 = n8;
      delay(10);
    }
    if (n10 != previousA10) {
      usbMIDI.sendControlChange(28, analogRead(10)>>3, 1);
      previousA10 = n10;
      delay(10);
    }
    if (n11 != previousA11) {
      usbMIDI.sendControlChange(29, analogRead(11)>>3, 1);
      previousA11 = n11;
      delay(10);
    }
    if (n12 != previousA12) {
      usbMIDI.sendControlChange(30, analogRead(12)>>3, 1);
      previousA12 = n12;
      delay(10);
    }
    if (n13 != previousA13) {
      usbMIDI.sendControlChange(31, analogRead(13)>>3, 1);
      previousA13 = n13;
      delay(10);
    }
    if (n14 != previousA14) {
      usbMIDI.sendControlChange(32, analogRead(A14)>>3, 1);
      previousA14 = n14;
      delay(10);
    }
    if (n17 != previousA17) {
      usbMIDI.sendControlChange(33, analogRead(A17)>>3, 1);
      previousA17 = n17;
      delay(10);
    }
    if (n18 != previousA18) {
      usbMIDI.sendControlChange(34, analogRead(A18)>>3, 1);
      previousA18 = n18;
      delay(10);
    }
    if (n19 != previousA19) {
      usbMIDI.sendControlChange(35, analogRead(A19)>>3, 1);
      previousA19 = n19;
      delay(10);
    }

}
while (usbMIDI.read()) {
    // ignore incoming messages
  }

  // ici c'est les switch on/off
  if (button2.fallingEdge()) {
    usbMIDI.sendControlChange(10, 127, 1);
  }
  if (button2.risingEdge()) {
    usbMIDI.sendControlChange(10, 0, 1);
  }
  if (button3.fallingEdge()) {
    usbMIDI.sendControlChange(11, 127, 1);
  }
  if (button3.risingEdge()) {
    usbMIDI.sendControlChange(11, 0, 1);
  }
  if (button4.fallingEdge()) {
    usbMIDI.sendControlChange(12, 127, 1);
  }
  if (button4.risingEdge()) {
    usbMIDI.sendControlChange(12, 0, 1);
  }
  if (button5.fallingEdge()) {
    usbMIDI.sendControlChange(13, 127, 1);
  }
  if (button5.risingEdge()) {
    usbMIDI.sendControlChange(13, 0, 1);
  }
  if (button6.fallingEdge()) {
    usbMIDI.sendControlChange(14, 127, 1);
  }
  if (button6.risingEdge()) {
    usbMIDI.sendControlChange(14, 0, 1);
  }
  if (button7.fallingEdge()) {
    usbMIDI.sendControlChange(15, 127, 1);
  }
  if (button7.risingEdge()) {
    usbMIDI.sendControlChange(15, 0, 1);
  }
  if (button8.fallingEdge()) {
    usbMIDI.sendControlChange(16, 127, 1);
  }
  if (button8.risingEdge()) {
    usbMIDI.sendControlChange(16, 0, 1);
  }
  if (button9.fallingEdge()) {
    usbMIDI.sendControlChange(17, 127, 1);
  }
  if (button9.risingEdge()) {
    usbMIDI.sendControlChange(17, 0, 1);
  }
  if (button10.fallingEdge()) {
    usbMIDI.sendControlChange(18, 127, 1);
  }
  if (button10.risingEdge()) {
    usbMIDI.sendControlChange(18, 0, 1);
  }
  if (button11.fallingEdge()) {
    usbMIDI.sendControlChange(19, 127, 1);
  }
  if (button11.risingEdge()) {
    usbMIDI.sendControlChange(19, 0, 1);
  }
  if (button12.fallingEdge()) {
    usbMIDI.sendControlChange(20, 127, 1);
  }
  if (button12.risingEdge()) {
    usbMIDI.sendControlChange(20, 0, 1);
  }
  if (button24.fallingEdge()) {
    usbMIDI.sendControlChange(22, 127, 1);
  }
  if (button24.risingEdge()) {
    usbMIDI.sendControlChange(22, 0, 1);
  }
  if (button26.fallingEdge()) {
    usbMIDI.sendControlChange(23, 127, 1);
  }
  if (button26.risingEdge()) {
    usbMIDI.sendControlChange(23, 0, 1);
  }
  if (button27.fallingEdge()) {
    usbMIDI.sendControlChange(24, 127, 1);
  }
  if (button27.risingEdge()) {
    usbMIDI.sendControlChange(24, 0, 1);
  }
  if (button31.fallingEdge()) {
    usbMIDI.sendControlChange(25, 127, 1);
  }
  if (button31.risingEdge()) {
    usbMIDI.sendControlChange(25, 0, 1);
  }

  
  //ici c'est le mpr121
 currtouched = cap.touched();
 
    for (uint8_t i=0; i<12; i++) {
 
        if ((currtouched & _BV(i)) && !(lasttouched & _BV(i)) ) {
            usbMIDI.sendNoteOn(i+octave,127,1);
        }
 
        if (!(currtouched & _BV(i)) && (lasttouched & _BV(i)) ) {
            usbMIDI.sendNoteOff(i+octave,0,1);
        }
 
    }
 
    lasttouched = currtouched;
 
}
